import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class HiraHiraMethod extends PApplet {static final int ROW = 15;
static final int MAX_P =ROW * ROW;
static final int MAX_S = 2*(ROW-1)*ROW;
static final float P_AIR = 0.95f;

static final int PITCH = 20;
static final int BEGX = 50;
static final int BEGY = 50;

static final int MAX_LENGTH = 10;
static final float INIT_W = 0.5f;

//##################################################
//    P
//##################################################
class P{
  float tx,ty;
  float x,y;
  float tvx,tvy;
  float vx,vy;
  float w;
  boolean fix;
  P(){
    fix=false;
    w=INIT_W;
    tx=x;
    ty=y;
    tvx=0;
    tvy=0;
  }
  public void setW(float _w){
    w = _w;
  }
  public void fix(boolean _fix){
    fix = _fix;
  }
  public void set(float _x,float _y){
    x = _x;
    y = _y;
  }
  public void paint(){
    //fill(0);
    //ellipse(x,y,5,5);
  }
  public void add(float _vx,float _vy){
    vx = vx + _vx;
    vy = vy + _vy;
  }
  public void act(){
    if(!fix){
      vy = vy + (0.1f)*w;

      x = x + vx;
      y = y + vy;

      vx = vx * P_AIR;
      vy = vy * P_AIR;
    }
  }


}

//##################################################
//  S
//##################################################
class S{
  P p1,p2;
  S(){
  }
  public void set(P _p1 , P _p2){
    p1 = _p1;
    p2 = _p2;
  }
  public void paint(){
    stroke(0);
    line(p1.x,p1.y,p2.x,p2.y);
  }
  public void act(){
    float d;
    float r;
    float pow;
    d = dist(p1.x,p1.y,p2.x,p2.y);
    if(d > MAX_LENGTH){
      pow = (d-MAX_LENGTH)/5.0f;
      r = atan2(p2.y-p1.y,p2.x-p1.x);
      if(!p1.fix){
        p1.add(cos(r)*pow,sin(r)*pow);
      }
      r = r + PI;
      if(!p2.fix){
        p2.add(cos(r)*pow,sin(r)*pow);
      }
    }
  }
}

P[] p = new P[MAX_P];
S[] s = new S[MAX_S];

int cnt;
float air;

//##################################################
//  setup
//##################################################
public void setup(){
  size(400,400);
  for(int i =0;i<MAX_P;i++){
    p[i] = new P();
  }
  for(int i =0;i<MAX_S;i++){
    s[i] = new S();
  }


  for(int i=0;i<ROW;i++){
    for(int j=0;j<ROW;j++){
      p[i*ROW+j].set(j*PITCH+BEGX,i*PITCH+BEGY);
    }
  }

  p[0].fix(true);
  p[ROW-1].fix(true);

  int c=0;


  for(int j=0;j<ROW;j++){
    for(int i=0;i<ROW-1;i++){
      s[c++].set(p[j*ROW+i],p[j*ROW+i+1]);
    }
  }
  for(int j=0;j<ROW;j++){
    for(int i=0;i<ROW-1;i++){
      s[c++].set(p[j+i*ROW],p[j+(i+1)*ROW]);
    }
  }

}

//##################################################
//    draw
//##################################################
public void draw(){

  cnt++;
  if(cnt>100){
    cnt=0;
    air = random(0.1f)-0.05f;
  }
  
  for(int i =0;i<MAX_P;i++){
    if(!p[i].fix){
      p[i].add(air,0);
    }
  }
  background(204);

  for(int i =0;i<MAX_S;i++){
    s[i].act();
  }
  for(int i =0;i<MAX_P;i++){
    p[i].act();
    p[i].paint();
  }


  for(int i =0;i<MAX_S;i++){
    s[i].paint();
  }
}

public void mousePressed(){
  p[ROW-1].x = mouseX;
  p[ROW-1].y = mouseY;
  p[ROW-1].fix(true);
  p[ROW-1].vx=0;
  p[ROW-1].vy=0;

}

  static public void main(String args[]) {     PApplet.main(new String[] { "HiraHiraMethod" });  }}